﻿function GetPluginSettings()
{
    return {
        "name": "Tapsell",
        "id": "VinoosTapsell",
        "version": "4.6.3",
        "description":	"Tapsell plugin for construct 2",
        "author": "Vinoos",
        "help url": "http://vinoos.ir/help/plugins/tapsell.php",
        "category": "Vinoos",
        "type": "object",
        "rotatable": false,
        "cordova-plugins": "https://github.com/vinoosir/tapsell-cordova-plugin",
        "flags": 0 | pf_singleglobal

    };
};

//////////////////////////////////////
// Conditions
	AddCondition(0, cf_trigger, "On Banner NoNetwork", "Banner", "On Banner NoNetwork", "On Banner NoNetwork", "onBannerNoNetwork");
	AddCondition(1, cf_trigger, "On Banner Error", "Banner", "On Banner Error", "On Banner Error", "onBannerError");
	AddCondition(2, cf_trigger, "On Banner NoAd Available", "Banner", "On Banner NoAd Available", "On Banner NoAd Available", "onBannerNoAdAvailable");
	AddCondition(3, cf_trigger, "On Banner Request Filled", "Banner", "On Banner Request Filled", "On Banner Request Filled", "onBannerRequestFilled");
	AddCondition(4, cf_trigger, "On Hide Banner", "Banner", "On Hide Banner", "On Hide Banner", "onBannerHideBannerView");
	
	AddCondition(5, cf_trigger, "On No Network", "Interstitial/Video", "On Interstitial No Network", "On No Network", "onInterstitialNoNetwork");
	AddCondition(6, cf_trigger, "On Error", "Interstitial/Video", "On Interstitial Error", "On Error", "onInterstitialError");
	AddCondition(7, cf_trigger, "On NoAd Available", "Interstitial/Video", "On Interstitial NoAd Available", "On NoAd Available", "onInterstitialNoAdAvailable");
	AddCondition(8, cf_trigger, "On Ad Available", "Interstitial/Video", "On Interstitial Ad Available", "On Ad Available", "onInterstitialAdAvailable");
	AddCondition(9, cf_trigger, "On Expiring", "Interstitial/Video", "On Interstitial Expiring", "On Expiring", "onInterstitialExpiring");
	AddCondition(10, cf_trigger, "On Show Failed", "Interstitial/Video", "On Interstitial Show Failed", "On Show Failed", "onInterstitialShowFailed");
	AddCondition(11, cf_trigger, "On Opened", "Interstitial/Video", "On Interstitial Opened", "On Opened", "onInterstitialOpened");
	AddCondition(12, cf_trigger, "On Closed", "Interstitial/Video", "On Interstitial Closed", "On Closed", "onInterstitialClosed");

	AddCondition(13, cf_trigger, "On Ad Show Finished", "Interstitial/Video", "On Ad Show Finished", "On Ad Show Finished", "onAdShowFinished");


//////////////////////////////////////
// Actions

	/*** - Banner Start - ***/
	AddStringParam("Zone ID", "Banner zone id");
	AddComboParamOption("TOP LEFT");
	AddComboParamOption("TOP CENTER");
	AddComboParamOption("TOP RIGHT");
	AddComboParamOption("LEFT");
	AddComboParamOption("CENTER");
	AddComboParamOption("RIGHT");
	AddComboParamOption("BOTTOM LEFT");
	AddComboParamOption("BOTTOM CENTER");
	AddComboParamOption("BOTTOM RIGHT");
	AddComboParam("Position", "Banner Position", 7);
	AddComboParamOption("320x50");
	AddComboParamOption("320x100");
	AddComboParamOption("250x250");
	AddComboParamOption("300x250");
	AddComboParam("Size", "Choose the banner size.", 0);
	AddAction(0, af_none, "Create Banner", "Banner", "Create Tapsell Banner", "Create Banner", "createBanner");
	
	AddStringParam("Zone ID", "Banner zone id");
	AddNumberParam("X", "Distance from left", 0);
	AddNumberParam("Y", "Distance from top", 0);
	AddComboParamOption("320x50");
	AddComboParamOption("320x100");
	AddComboParamOption("250x250");
	AddComboParamOption("300x250");
	AddComboParam("Size", "Choose the banner size.", 0);
	AddAction(1, af_none, "Create Banner At XY", "Banner", "Create Banner At XY", "Create Banner At XY", "createBannerAtXY");
	
	AddAction(2, af_none, "Remove Banner", "Banner", "Remove Banner", "Remove Banner", "removeBanner");
	
	AddAction(3, af_none, "Show Banner", "Banner", "Show Banner", "Show Banner", "showBanner");
	
	AddAction(4, af_none, "Hide Banner", "Banner", "Hide Banner", "Hide Banner", "hideBanner");
	
	AddStringParam("Zone ID", "Banner zone id");
	AddNumberParam("Position", "Enter banner position", 7);
	AddNumberParam("Size", "Enter the banner size", 0);
	AddAction(7, af_none, "Create Banner 2", "Banner", "Create Tapsell Banner", "Create Banner", "createBanner");
	
	AddStringParam("Zone ID", "Banner zone id");
	AddNumberParam("X", "Distance from left", 0);
	AddNumberParam("Y", "Distance from top", 0);
	AddNumberParam("Size", "Enter the banner size", 0);
	AddAction(8, af_none, "Create Banner At XY 2", "Banner", "Create Banner At XY", "Create Banner At XY 2", "createBannerAtXY");
	/*** - Banner End - ***/
	
	/*** - Interstitial/Video Start - ***/
	AddStringParam("Zone ID", "Banner zone id");
	AddComboParamOption("CACHED");
	AddComboParamOption("STREAMED");
	AddComboParam("Cache Type", "Choose cache type.", 0);
	AddAction(5, af_none, "Request Ad", "Interstitial/Video", "Request Ad", "Request Ad", "requestAd");
	
	AddComboParamOption("False");
	AddComboParamOption("True");
	AddComboParam("Back Disabled", "Disable back button when showing ad.", 0);
	AddComboParamOption("False");
	AddComboParamOption("True");
	AddComboParam("Immersive Mode", "Enable immersive mode when showing ad.", 0);
	AddComboParamOption("LOCKED PORTRAIT");
	AddComboParamOption("LOCKED LANDSCAPE");
	AddComboParamOption("UNLOCKED");
	AddComboParamOption("LOCKED REVERSED LANDSCAPE");
	AddComboParamOption("LOCKED REVERSED PORTRAIT");
	AddComboParam("Rotation Mode", "Set screen rotation mode when showing ad.", 2);
	AddComboParamOption("False");
	AddComboParamOption("True");
	AddComboParam("Show Dialog", "Show warning dialog when user press back button while playing rewarded video ad.", 1);
	AddAction(6, af_none, "Show Ad", "Interstitial/Video", "Show Ad", "Show Ad", "showAd");
	/*** - Interstitial/Video End - ***/


//////////////////////////////////////////////////////////////
// Expressions
	AddExpression(1, ef_return_string, "Returns last error message.", "Interstitial/Video", "ErrorMessage", "Returns last error message.");
	AddExpression(2, ef_return_number, "Returns is ad completed.", "Interstitial/Video", "Completed", "Returns is ad completed.");
	AddExpression(3, ef_return_string, "Returns reward token id.", "Interstitial/Video", "RewardId", "Returns reward token id.");
	AddExpression(4, ef_return_number, "Returns is rewarded ad.", "Interstitial/Video", "IsRewardedAd", "Returns is rewarded ad.");

ACESDone();

//////////////////////////////////////
// Properties
	var property_list = [
		new cr.Property(ept_text, "App Key", "", "Tapsell app key for your application")
	];

// Called by IDE when a new object type is to be created
function CreateIDEObjectType()
{
    return new IDEObjectType();
}

// Class representing an object type in the IDE
function IDEObjectType()
{
    assert2(this instanceof arguments.callee, "Constructor called as a function");
}

// Called by IDE when a new object instance of this type is to be created
IDEObjectType.prototype.CreateInstance = function(instance)
{
    return new IDEInstance(instance);
}

// Class representing an individual instance of an object in the IDE
function IDEInstance(instance, type)
{
    assert2(this instanceof arguments.callee, "Constructor called as a function");

    // Save the constructor parameters
    this.instance = instance;
    this.type = type;

    // Set the default property values from the property table
    this.properties = {};

    for (var i = 0; i < property_list.length; i++)
        this.properties[property_list[i].name] = property_list[i].initial_value;

    // Plugin-specific variables
    // this.myValue = 0...
}

// Called when inserted via Insert Object Dialog for the first time
IDEInstance.prototype.OnInserted = function()
{
}

// Called when double clicked in layout
IDEInstance.prototype.OnDoubleClicked = function()
{
}

// Called after a property has been changed in the properties bar
IDEInstance.prototype.OnPropertyChanged = function(property_name)
{
}

// For rendered objects to load fonts or textures
IDEInstance.prototype.OnRendererInit = function(renderer)
{
}

// Called to draw self in the editor if a layout object
IDEInstance.prototype.Draw = function(renderer)
{
}

// For rendered objects to release fonts or textures
IDEInstance.prototype.OnRendererReleased = function(renderer)
{
}

