// ECMAScript 5 strict mode
"use strict";

assert2(cr, "cr namespace not created");
assert2(cr.plugins_, "cr.plugins_ not created");

cr.plugins_.VinoosTapsell = function(runtime)
{
	this.runtime = runtime;
};

(function ()
{	
	var pluginProto = cr.plugins_.VinoosTapsell.prototype;
		
/////////////////////////////////////
// Object type class
	pluginProto.Type = function(plugin)
	{
		this.plugin = plugin;
		this.runtime = plugin.runtime;
	};

	var typeProto = pluginProto.Type.prototype;

	var rewardId = "";
	var errorMessage = "";
	var completed = false;
	var rewardedAd = false;
	
// called on startup for each object type
	typeProto.onCreate = function()
	{
		if(this.runtime.isBlackberry10 || this.runtime.isWindows8App || this.runtime.isWindowsPhone8 || this.runtime.isWindowsPhone81){
			var scripts=document.getElementsByTagName("script");
			var scriptExist=false;
			for(var i=0;i<scripts.length;i++){
				if(scripts[i].src.indexOf("cordova.js")!=-1||scripts[i].src.indexOf("phonegap.js")!=-1){
					scriptExist=true;
					break;
				}
			}
			if(!scriptExist){
				var newScriptTag=document.createElement("script");
				newScriptTag.setAttribute("type","text/javascript");
				newScriptTag.setAttribute("src", "cordova.js");
				document.getElementsByTagName("head")[0].appendChild(newScriptTag);
			}
		}
	};

/////////////////////////////////////
// Instance class
	pluginProto.Instance = function(type)
	{
		this.type = type;
		this.runtime = type.runtime;
	};
	
	var instanceProto = pluginProto.Instance.prototype;
	
	var isSupported = false;
	
// called whenever an instance is created
	instanceProto.onCreate = function()
	{
		if (!window["Tapsell"])
		{
			cr.logexport("[Construct 2] com.cranberrygame.phonegap.plugin.ad.admob plugin is required to show Admob ads with Cordova; other platforms are not supported");
			return;
		}
		
		isSupported = true;
		
		var self = this;
		
		var appKey = this.properties[0];
		
		Tapsell.initialize(appKey);
	
		document.addEventListener('onNoNetwork',function(data){
			if(data.adType == 'banner') {
				self.runtime.trigger(cr.plugins_.VinoosTapsell.prototype.cnds.onBannerNoNetwork, self);
			} else if(data.adType == 'nonBanner') {
				self.runtime.trigger(cr.plugins_.VinoosTapsell.prototype.cnds.onInterstitialNoNetwork, self);
			}
		});
		
		document.addEventListener('onError',function(data){
			if(data.adType == 'banner') {
				self.runtime.trigger(cr.plugins_.VinoosTapsell.prototype.cnds.onBannerError, self);
			} else if(data.adType == 'nonBanner') {
				errorMessage = data.message;
				self.runtime.trigger(cr.plugins_.VinoosTapsell.prototype.cnds.onInterstitialError, self);
			}
		});
		
		document.addEventListener('onNoAdAvailable',function(data){
			if(data.adType == 'banner') {
				self.runtime.trigger(cr.plugins_.VinoosTapsell.prototype.cnds.onBannerNoAdAvailable, self);
			} else if(data.adType == 'nonBanner') {
				self.runtime.trigger(cr.plugins_.VinoosTapsell.prototype.cnds.onInterstitialNoAdAvailable, self);
			}
		});
		
		document.addEventListener('onRequestFilled',function(data){
			self.runtime.trigger(cr.plugins_.VinoosTapsell.prototype.cnds.onBannerRequestFilled, self);
		});
		
		document.addEventListener('onHideBannerView',function(data){
			self.runtime.trigger(cr.plugins_.VinoosTapsell.prototype.cnds.onBannerHideBannerView, self);
		});
		
		document.addEventListener('onAdAvailable',function(data){
			self.runtime.trigger(cr.plugins_.VinoosTapsell.prototype.cnds.onInterstitialAdAvailable, self);
		});
		
		document.addEventListener('onExpiring',function(data){
			self.runtime.trigger(cr.plugins_.VinoosTapsell.prototype.cnds.onInterstitialExpiring, self);
		});
		
		document.addEventListener('onShowFailed',function(data){
			self.runtime.trigger(cr.plugins_.VinoosTapsell.prototype.cnds.onInterstitialShowFailed, self);
		});
		
		document.addEventListener('onOpened',function(data){
			self.runtime.trigger(cr.plugins_.VinoosTapsell.prototype.cnds.onInterstitialOpened, self);
		});
		
		document.addEventListener('onClosed',function(data){
			self.runtime.trigger(cr.plugins_.VinoosTapsell.prototype.cnds.onInterstitialClosed, self);
		});
		
		document.addEventListener('onAdShowFinished',function(data){
			rewardId = data.id;
			completed = data.completed;
			rewardedAd = data.isRewardedAd;
			self.runtime.trigger(cr.plugins_.VinoosTapsell.prototype.cnds.onAdShowFinished, self);
		});

	};
	
	instanceProto.draw = function(ctx)
	{
	};
	instanceProto.drawGL = function (glw)
	{
	};

//////////////////////////////////////
// Conditions
	function Cnds() {};

	/*** - Banner Conditions - ***/
	Cnds.prototype.onBannerNoNetwork = function () {
		return true;
	};
	
	Cnds.prototype.onBannerError = function () {
		return true;
	};
	
	Cnds.prototype.onBannerNoAdAvailable = function () {
		return true;
	};
	
	Cnds.prototype.onBannerRequestFilled = function () {
		return true;
	};
	
	Cnds.prototype.onBannerHideBannerView = function () {
		return true;
	};
	
	/*** - Interstitial Conditions - ***/
	Cnds.prototype.onInterstitialNoNetwork = function () {
		return true;
	};
	
	Cnds.prototype.onInterstitialError = function () {
		return true;
	};
	
	Cnds.prototype.onInterstitialNoAdAvailable = function () {
		return true;
	};
	
	Cnds.prototype.onInterstitialAdAvailable = function () {
		return true;
	};
	
	Cnds.prototype.onInterstitialExpiring = function () {
		return true;
	};
	
	Cnds.prototype.onInterstitialShowFailed = function () {
		return true;
	};
	
	Cnds.prototype.onInterstitialOpened = function () {
		return true;
	};
	
	Cnds.prototype.onInterstitialClosed = function () {
		return true;
	};
	
	Cnds.prototype.onAdShowFinished = function () {
		return true;
	};
	
	pluginProto.cnds = new Cnds();
	
//////////////////////////////////////
// Actions
	function Acts() {};
	
	Acts.prototype.createBanner = function (zoneid, position, size) {
		if (!isSupported)
			return;
		
		Tapsell.createBanner(zoneid, position, (size+1));
	};
	
	Acts.prototype.createBannerAtXY = function (zoneid, x, y, size) {
		if (!isSupported)
			return;
		
		Tapsell.createBannerAtXY(zoneid, x, y, (size+1));
	};
	
	Acts.prototype.removeBanner = function () {
		if (!isSupported)
			return;
		
		Tapsell.removeBanner();
	};
	
	Acts.prototype.showBanner = function () {
		if (!isSupported)
			return;
		
		Tapsell.showBanner();
	};
	
	Acts.prototype.hideBanner = function () {
		if (!isSupported)
			return;
		
		Tapsell.hideBanner();
	};
	
	Acts.prototype.requestAd = function (zoneid, cachetype) {
		if (!isSupported)
			return;
		
		Tapsell.requestAd(zoneid, (cachetype+1));
	};
	
	Acts.prototype.showAd = function (backDisabled, immersiveMode, rotationMode, showDialog) {
		if (!isSupported)
			return;
		
		Tapsell.showAd(backDisabled!=0?true:false, immersiveMode!=0?true:false, (rotationMode+1), showDialog!=0?true:false);
	};
	
	pluginProto.acts = new Acts();
	
//////////////////////////////////////
// Expressions
	function Exps() {};

	Exps.prototype.ErrorMessage = function (ret) {
		ret.set_string(errorMessage);
	};

	Exps.prototype.Completed = function (ret) {
		ret.set_int(completed?1:0);
	};

	Exps.prototype.RewardId = function (ret) {
		ret.set_string(rewardId);
	};

	Exps.prototype.IsRewardedAd = function (ret) {
		ret.set_int(isRewardedAd?1:0);
	};
	
	pluginProto.exps = new Exps();

}());